SmilesParse.h
Go to the documentation of this file.
//
// Copyright (C) 2001-2016 Greg Landrum and Rational Discovery LLC
//
// @@ All Rights Reserved @@
// This file is part of the RDKit.
// The contents are covered by the terms of the BSD license
// which is included in the file license.txt, found at the root
// of the RDKit source tree.
//
#include <RDGeneral/export.h>
#ifndef _RD_SMILESPARSE_H_
#define _RD_SMILESPARSE_H_
#include <GraphMol/RWMol.h>
#include <GraphMol/SanitException.h>
#include <string>
#include <exception>
#include <map>
namespace RDKit {
struct RDKIT_SMILESPARSE_EXPORT SmilesParserParams {
int debugParse;
bool sanitize;
std::map<std::string, std::string> *replacements;
bool allowCXSMILES;
bool parseName;
bool removeHs;
SmilesParserParams()
: debugParse(0),
sanitize(true),
replacements(NULL),
allowCXSMILES(true),
parseName(false),
removeHs(true){};
};
RDKIT_SMILESPARSE_EXPORT RWMol *SmilesToMol(const std::string &smi,
const SmilesParserParams &params);
RDKIT_SMILESPARSE_EXPORT Atom *SmilesToAtom(const std::string &smi);
RDKIT_SMILESPARSE_EXPORT Bond *SmilesToBond(const std::string &smi);
//! Construct a molecule from a SMILES string
/*!
\param smi the SMILES to convert
\param debugParse toggles verbose debugging information from the parser
\param sanitize toggles H removal and sanitization of the molecule
\param replacements a string->string map of replacement strings. See below
for more information about replacements.
\return a pointer to the new molecule; the caller is responsible for free'ing
this.
The optional replacements map can be used to do string substitution of
abbreviations
in the input SMILES. The set of substitutions is repeatedly looped through
until
the string no longer changes. It is the responsiblity of the caller to make
sure
that substitutions results in legal and sensible SMILES.
Examples of substitutions:
\code
CC{Q}C with {"{Q}":"OCCO"} -> CCOCCOC
C{A}C{Q}C with {"{Q}":"OCCO", "{A}":"C1(CC1)"} -> CC1(CC1)COCCOC
C{A}C{Q}C with {"{Q}":"{X}CC{X}", "{A}":"C1CC1", "{X}":"N"} -> CC1CC1CCNCCNC
\endcode
*/
inline RWMol *SmilesToMol(
const std::string &smi, int debugParse = 0, bool sanitize = true,
std::map<std::string, std::string> *replacements = 0) {
SmilesParserParams params;
params.debugParse = debugParse;
params.replacements = replacements;
if (sanitize) {
params.sanitize = true;
params.removeHs = true;
} else {
params.sanitize = false;
params.removeHs = false;
}
return SmilesToMol(smi, params);
};
//! Construct a molecule from a SMARTS string
/*!
\param sma the SMARTS to convert
\param debugParse toggles verbose debugging information from the parser
\param mergeHs toggles merging H atoms in the SMARTS into neighboring
atoms
\param replacements a string->string map of replacement strings.
\see SmilesToMol for more information about replacements
\return a pointer to the new molecule; the caller is responsible for free'ing
this.
*/
RDKIT_SMILESPARSE_EXPORT RWMol *SmartsToMol(
const std::string &sma, int debugParse = 0, bool mergeHs = false,
std::map<std::string, std::string> *replacements = 0);
RDKIT_SMILESPARSE_EXPORT Atom *SmartsToAtom(const std::string &sma);
RDKIT_SMILESPARSE_EXPORT Bond *SmartsToBond(const std::string &sma);
class RDKIT_SMILESPARSE_EXPORT SmilesParseException : public std::exception {
public:
SmilesParseException(const char *msg) : _msg(msg){};
SmilesParseException(const std::string msg) : _msg(msg){};
const char *message() const { return _msg.c_str(); };
~SmilesParseException() throw(){};
private:
std::string _msg;
};
inline std::unique_ptr<RDKit::RWMol> operator"" _smiles(const char *text,
size_t len) {
std::string smi(text, len);
RWMol *ptr = nullptr;
try {
ptr = SmilesToMol(smi);
} catch (const RDKit::MolSanitizeException &) {
ptr = nullptr;
}
return std::unique_ptr<RWMol>(ptr);
}
inline std::unique_ptr<RDKit::RWMol> operator"" _smarts(const char *text,
size_t len) {
std::string smi(text, len);
RWMol *ptr = nullptr;
try {
ptr = SmartsToMol(smi);
} catch (const RDKit::MolSanitizeException &) {
ptr = nullptr;
}
return std::unique_ptr<RWMol>(ptr);
}
} // namespace RDKit
#endif
RDKit::SmilesParseException::~SmilesParseException
~SmilesParseException()
Definition: SmilesParse.h:110
RDKit::SmilesParserParams::debugParse
int debugParse
Definition: SmilesParse.h:23
RDKit::SmilesParserParams::sanitize
bool sanitize
Definition: SmilesParse.h:24
RDKit::SmilesToAtom
RDKIT_SMILESPARSE_EXPORT Atom * SmilesToAtom(const std::string &smi)
RDKit::RWMol
RWMol is a molecule class that is intended to be edited.
Definition: RWMol.h:31
RDKit::SmartsToMol
RDKIT_SMILESPARSE_EXPORT RWMol * SmartsToMol(const std::string &sma, int debugParse=0, bool mergeHs=false, std::map< std::string, std::string > *replacements=0)
Construct a molecule from a SMARTS string.
RDKit::SmilesToMol
RDKIT_SMILESPARSE_EXPORT RWMol * SmilesToMol(const std::string &smi, const SmilesParserParams &params)
RDKit::SmilesToBond
RDKIT_SMILESPARSE_EXPORT Bond * SmilesToBond(const std::string &smi)
RDKit::MolSanitizeException
class for flagging sanitization errors
Definition: SanitException.h:27
RDKit::SmilesParserParams::SmilesParserParams
SmilesParserParams()
Definition: SmilesParse.h:29
RDKit::SmilesParserParams::parseName
bool parseName
Definition: SmilesParse.h:27
RDKit::SmilesParseException
Definition: SmilesParse.h:105
RDKit::SmilesParserParams::replacements
std::map< std::string, std::string > * replacements
Definition: SmilesParse.h:25
RDKit::SmilesParserParams::removeHs
bool removeHs
Definition: SmilesParse.h:28
SanitException.h
RDKit::SmilesParseException::SmilesParseException
SmilesParseException(const char *msg)
Definition: SmilesParse.h:107
RDKit
Std stuff.
Definition: Atom.h:30
RDKit::SmilesParseException::SmilesParseException
SmilesParseException(const std::string msg)
Definition: SmilesParse.h:108
RDKit::SmilesParseException::message
const char * message() const
Definition: SmilesParse.h:109
RDKit::SmilesParserParams::allowCXSMILES
bool allowCXSMILES
Definition: SmilesParse.h:26
RDKIT_SMILESPARSE_EXPORT
#define RDKIT_SMILESPARSE_EXPORT
Definition: export.h:632
RDKit::SmilesParserParams
Definition: SmilesParse.h:22
RDKit::MolOps::removeHs
RDKIT_GRAPHMOL_EXPORT ROMol * removeHs(const ROMol &mol, bool implicitOnly=false, bool updateExplicitCount=false, bool sanitize=true)
returns a copy of a molecule with hydrogens removed
RWMol.h
Defines the editable molecule class RWMol.
RDKit::SmartsToAtom
RDKIT_SMILESPARSE_EXPORT Atom * SmartsToAtom(const std::string &sma)
RDKit::SmartsToBond
RDKIT_SMILESPARSE_EXPORT Bond * SmartsToBond(const std::string &sma)
export.h